
#include "tricks.h"

#include <conio.h>
#include <stdio.h>

#define punkts 8
#define faces  12

struct facep
{
   float x,y,z;
   float px,py;
};

// ********

facep kubp[8];
facep rotp[8];
int   kubf[12][4];

int startx[200];
int endx[200];

int y_tab[200];

void load( char *file, byte *data, unsigned int length );

// ********

void initpoint( int point, float x, float y, float z);
void initface ( int face, int a, int b, int c, int d);

void initall();

void rotate();
void project();

void polydraw();
void Poly( int Face , byte color );
void polyfix( int x1, int x2, int y1, int y2);
void blah( int x1, int y1, int x2, int y2);

byte buffer[64000];
byte Texture[4096];

// **********

int main()
{
   SetMCGA();

   initall();

   do
   {
      rotate();
      project();
      polydraw();
      WaitRetrace();

      memcpy( vga, buffer, 64000);
      memset( buffer, 0, 64000);

   } while ( !kbhit() );

   SetText();

   return 0;
}


// ************ DRAW ******************************************

void polyfix( int x1, int y1, int x2, int y2)
{
   if( y2 < y1 )  
   {
      int temp = y1;
      y1 = y2;
      y2 = temp;

      temp = x1;
      x1 = x2;
      x2 = temp;
   }

   if( y2 == y1 )
   {
      startx[y1] = x1;
      endx  [y1] = x2;
   }
   else
   {
      int X, Y, Step;
      X = x1 << 16;
      Step = ((x2-x1) << 16) / (y2-y1);
      X += Step;
      y1++;

      for( Y = y1; Y <= y2; Y++)
      {
         if( (Y>=0) && (Y<200) )
         {
            if( startx[ Y ] == -1)
               startx[ Y ] = (X >> 16);
            else
               if( (X >> 16) < 320 )
                  endx[ Y ] = (X >> 16);
               else
                  endx[ Y ] = 319;
            }

         X += Step;
      }
   }
}

void polydraw()
{
      Poly( 0, 40);
      Poly( 1, 45);

      Poly( 4, 20);
      Poly( 5, 25);

      Poly( 2, 30);
      Poly( 3, 35);

      Poly( 6, 40);
      Poly( 7, 45);

      Poly( 8, 50);
      Poly( 9, 55);

      Poly( 10, 20);
      Poly( 11, 25);
}


void Poly( int Face, byte color )
{
   for( int i=0; i<200; i++)
   {
      startx[i] |= ~startx[i];
      endx[i]   |= ~endx[i];
   }

   polyfix( rotp[ kubf[Face][0] ].px,
            rotp[ kubf[Face][0] ].py,
            rotp[ kubf[Face][1] ].px,
            rotp[ kubf[Face][1] ].py );

   polyfix( rotp[ kubf[Face][1] ].px,
            rotp[ kubf[Face][1] ].py,
            rotp[ kubf[Face][2] ].px,
            rotp[ kubf[Face][2] ].py );

   polyfix( rotp[ kubf[Face][2] ].px,
            rotp[ kubf[Face][2] ].py,
            rotp[ kubf[Face][0] ].px,
            rotp[ kubf[Face][0] ].py );

   for( i=50; i<150; i++ )
   {
      if( startx[i] != -1 )
      {         
         int start = startx[i];
         int end   = endx[i];

         if( end == -1)
             buffer[ y_tab[i]+start ] = color;
         else
         {
            if( start > end )
            {
               int temp=start;
               start = end;
               end = temp;
            }

            byte* tmp = buffer+y_tab[i];

            for( int x=start+1; x<=end; x++)
            {
               tmp[x] = (tmp[x] + color) >> 1;
            }
         }
      }
   }
}



// ************ PROJECT ***************************************

void rotate()
{
   static double angle = 0;

   angle += 0.03;
	
   float sinX = sin(angle);
   float cosX = cos(angle);

   float sinY = sin(angle);
   float cosY = cos(angle);

   float sinZ = sin(angle);
   float cosZ = cos(angle);

   float temp;

   for( int i=0; i<8; i++)       
	{
      rotp[i].x = kubp[i].x * cosZ + kubp[i].y * sinZ;
      rotp[i].y = kubp[i].y * cosZ - kubp[i].x * sinZ;

      rotp[i].z = kubp[i].z * cosY - rotp[i].x * sinY;
      rotp[i].x = rotp[i].x * cosY + kubp[i].z * sinY;

      temp      = rotp[i].y * cosX + rotp[i].z * sinX;
      rotp[i].z = rotp[i].z * cosX - rotp[i].y * sinX;
      rotp[i].y = temp;
	}
}

void project()
{
   for( int i=0; i<8; i++ )
   {
      rotp[i].px = (( rotp[i].x / (rotp[i].z + 12)) * 490) + 160;      
      rotp[i].py = (( rotp[i].y / (rotp[i].z + 12)) * 420) + 100;      
   }
}

// ************* INITS *****************************************

void initall()
{
   for( int i=0; i<200; i++ )
   {
      y_tab[i] = i*320;
   }

   for( i=1; i<64; i++)
   {
      Pal(i,i,0,i);
   }

   Pal( 0,0,0,0 );

   for( i=0; i<200; i++)
   {
      startx[i] = -1;
        endx[i] = -1;
   }

   initpoint( 0,  1,  1, 1 );
   initpoint( 1,  1, -1, 1 );
   initpoint( 2, -1, -1, 1 );
   initpoint( 3, -1,  1, 1 );

   initpoint( 4,  1,  1, -1 );
   initpoint( 5,  1, -1, -1 );
   initpoint( 6, -1, -1, -1 );
   initpoint( 7, -1,  1, -1 );

   initface( 0, 4,0,1,1);
   initface( 1, 4,5,1,1);

   initface( 2, 0,3,2,2);
   initface( 3, 0,1,2,2);
      
   initface( 4, 3,7,6,6);
   initface( 5, 3,2,6,6);

   initface( 6, 7,4,5,5);
   initface( 7, 7,6,5,5);

   initface( 8, 5,1,2,2);
   initface( 9, 5,6,2,2);

   initface( 10, 7,3,0,0);
   initface( 11, 7,4,0,0);
}

void initpoint( int point, float x, float y, float z)
{
   kubp[point].x = x;
   kubp[point].y = y;
   kubp[point].z = z;
}

void initface ( int face, int a, int b, int c, int d)
{
   kubf[face][0] = a;
   kubf[face][1] = b;
   kubf[face][2] = c;
   kubf[face][3] = d;
}
